//+------------------------------------------------------------------+
//|                                                       proga2.mq4 |
//|                                                           |
//|                                      http//dimarik0000@yandex.ru |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "http//dimarik0000@yandex.ru"

extern double StopLoss=50;
extern double TakeProfit=100;
extern double TrailingStop=20;
extern double Lots=0.2;
extern double Slippage=2;

extern double MACD_fast_ema_period=12, MACD_slow_ema_period=26, MACD_signal_period=9;
extern double MACDOpenLevel=1;
extern double MACDClosLevel=1;

extern double MA1=21;
extern double MA2=8;
extern double MA=200;
       double total=1;
       

extern int Magic=777; //   .      
extern int Delta=20; // 
extern int TrallSize=10;// .  0,  .
extern string symb; //   
bool Signal;
double Price;
datetime LastTime;
//+------------------------------------------------------------------+
//|     TYPE,         |
//+------------------------------------------------------------------+
int OrderExists(int Type) //      ( )
  {    
    if (OrdersTotal()==0) return(-1); //     
    for (int i=0; i<OrdersTotal(); i++) //  
    if (OrderSelect(i,SELECT_BY_POS) && OrderType()==Type && OrderMagicNumber()==Magic) return(OrderTicket()); 
    //         .   
    return(-1);  
  }  
//+------------------------------------------------------------------+
//|     BUY                                  |
//+------------------------------------------------------------------+
int CloseBuyOrders() //      Buy
  {
    while (OrderExists(OP_BUY)>0) //          
    {
      RefreshRates(); //   
      OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,0); //           
    }      
  }
//+------------------------------------------------------------------+
//|     SELL                                 |
//+------------------------------------------------------------------+
int CloseSellOrders() //     Sell
  {
    while (OrderExists(OP_SELL)>0) //          
    {
      RefreshRates();  //   
      OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage, Red); //       
    }      
  }
//+------------------------------------------------------------------+
//|       PIPS,                 |
//+------------------------------------------------------------------+
void Tralling(int Pips) //    
  {
    int n=OrdersTotal(); //   n 
    for(int i=0;i<n;i++) // 
      if (OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==Magic && OrderSymbol()==Symbol()) //       
      {  
        double SL = OrderStopLoss(); //   SL
        RefreshRates(); //  
        if (OrderType()==OP_BUY && Ask>SL+(StopLoss+Pips)*Point)                                                    
          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL+Pips*Point,Digits), OrderTakeProfit(), 0,0);
        if (OrderType()==OP_SELL && Bid<SL-(StopLoss+Pips)*Point) 
          OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL-Pips*Point,Digits),OrderTakeProfit(), 0,0);        
      }
  }

  
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
    Signal = -1;
    return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
    return(0);
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
int BuyMarket() //    Buy
  {
     CloseSellOrders();
     CloseBuyOrders();
     RefreshRates();    
     double op = NormalizeDouble(Ask,Digits); //           
     double tp = NormalizeDouble(Ask + TakeProfit*Point,Digits); //        
     if (TakeProfit==0) tp=0;
     double sl = NormalizeDouble(Ask - StopLoss*Point,Digits); //        
     if (StopLoss==0) sl=0;     
     Print("        ASK=" + DoubleToStr(Ask,Digits));                                 
     OrderSend(Symbol(),OP_BUY, Lots, op, Slippage, sl, tp, "", Magic, 0 ,0);
   }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
int SellMarket() 
  {
     CloseBuyOrders();
     CloseSellOrders();
     RefreshRates();
     double op = NormalizeDouble(Bid,Digits);  //           
     double tp = NormalizeDouble(Bid - TakeProfit*Point,Digits); //        
     if (TakeProfit==0) tp=0;
     double sl = NormalizeDouble(Bid + StopLoss*Point,Digits); //        
     if (StopLoss==0) sl=0;
     Print("        BID=" + DoubleToStr(Bid,Digits));  
     OrderSend(Symbol(), OP_SELL, Lots, op, Slippage, sl, tp, "", Magic, 0 ,0);
  }

  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if (TrallSize>0 && StopLoss!=0) Tralling(TrallSize);
  
   
   if (Signal==OP_BUY && Bid>=Price+(Delta)*Point) BuyMarket(); //  
   if (Signal==OP_SELL && Bid<=Price-(Delta)*Point) SellMarket(); //  
   
   double CO = MathAbs(Bid-Price)/Point;
   if (Signal!=-1) 
     Comment("  Bid   : " + DoubleToStr(Price,Digits) + "\n" +
             " : " + DoubleToStr(CO, 0) + ", : " + Delta);
   else
     Comment("  ...");        
   
   // ,  ,      
   if (LastTime==Time[0]) return(0);
   LastTime=Time[0];      
         
   double MA1=iMA(NULL,0,21,0,MODE_EMA,PRICE_CLOSE,0);
   double MA2=iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,0);
   double MA=iMA(NULL,0,200,0,MODE_EMA,PRICE_CLOSE,0);
   
   double MACD1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   double MACD2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);
      
   //    
   if (MA>MA1 && MA>MA2)
    {
      if (MACD1<0 && MACD2<MACD1 && MACDOpenLevel*Point && MA1>MA2*Point)
      {   
        Signal = OP_SELL;       
        Price = Close[1];    
        Print("   ,  = " + DoubleToStr(Price, Digits));
        PlaySound("alert.wav");         
      }
    }
   
   //    
   if (MA<MA1 && MA<MA2)
     {
      if (MACD1>0 && MACD2>MACD1 && MACDOpenLevel*Point && MA1<MA2*Point)
       {
        Signal = OP_BUY;            
        Price = Close[1];
        Print("   ,  = " + DoubleToStr(Price, Digits));
        PlaySound("alert.wav");                
       }
     }
    return(0);
  }
//+------------------------------------------------------------------+